Gecode::Int::Bool::Clause< VX, VY > Class Template Reference
Other available functionality » Integer propagators

Boolean clause propagator (disjunctive). More...

`#include <bool.hh>`

## Classes

class | Tagged
| Advisors for views (tagged whether for x or y) More...

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Give advice to propagator.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low unary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< VX > &x, ViewArray< VY > &y, VX z)
| Post propagator .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

void | cancel (Space &home)
| Cancel subscriptions.
| Clause (Home home, ViewArray< VX > &x, ViewArray< VY > &y, VX z)
| Constructor for posting.
| Clause (Space &home, Clause< VX, VY > &p)
| Constructor for cloning p.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< VX > | x
| Positive views.
ViewArray< VY > | y
| Positive views (origin from negative variables).
VX | z
| Result.
int | n_zero
| The number of views assigned to zero in x and y.
Council< Tagged > | c
| The advisor council.

## Detailed Description

template<class VX, class VY>
class Gecode::Int::Bool::Clause< VX, VY >

Boolean clause propagator (disjunctive).

Requires

#include <gecode/int/bool.hh>
bool.hh

Definition at line 492 of file bool.hh.

## Constructor & Destructor Documentation

## Clause() [1/2]

template<class VX, class VY>

Gecode::Int::Bool::Clause< VX, VY >::Clause | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | ViewArray< VY > & | y,
|  | VX | z )

inline protected

Constructor for posting.

Definition at line 204 of file clause.hpp.

## Clause() [2/2]

template<class VX, class VY>

Gecode::Int::Bool::Clause< VX, VY >::Clause | ( | Space & | home,
|  | Clause< VX, VY > & | p )

inline protected

Constructor for cloning p.

Definition at line 214 of file clause.hpp.

## Member Function Documentation

## cancel()

template<class VX, class VY>

void Gecode::Int::Bool::Clause< VX, VY >::cancel | ( | Space & | home | ) |

inline protected

Cancel subscriptions.

Definition at line 293 of file clause.hpp.

## copy()

template<class VX, class VY>

Actor * Gecode::Int::Bool::Clause< VX, VY >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 238 of file clause.hpp.

## advise()

template<class VX, class VY>

ExecStatus Gecode::Int::Bool::Clause< VX, VY >::advise | ( | Space & | home,
|  | Advisor & | a,
|  | const Delta & | d )

virtual

Give advice to propagator.

Reimplemented from Gecode::Propagator.

Definition at line 316 of file clause.hpp.

## cost()

template<class VX, class VY>

PropCost Gecode::Int::Bool::Clause< VX, VY >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low unary).

Implements Gecode::Propagator.

Definition at line 287 of file clause.hpp.

## reschedule()

template<class VX, class VY>

void Gecode::Int::Bool::Clause< VX, VY >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 327 of file clause.hpp.

## propagate()

template<class VX, class VY>

ExecStatus Gecode::Int::Bool::Clause< VX, VY >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 345 of file clause.hpp.

## post()

template<class VX, class VY>

ExecStatus Gecode::Int::Bool::Clause< VX, VY >::post | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | ViewArray< VY > & | y,
|  | VX | z )

inline static

Post propagator .

Definition at line 246 of file clause.hpp.

## dispose()

template<class VX, class VY>

size_t Gecode::Int::Bool::Clause< VX, VY >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 307 of file clause.hpp.

## Member Data Documentation

## x

template<class VX, class VY>

ViewArray<VX> Gecode::Int::Bool::Clause< VX, VY >::x

protected

Positive views.

Definition at line 495 of file bool.hh.

## y

template<class VX, class VY>

ViewArray<VY> Gecode::Int::Bool::Clause< VX, VY >::y

protected

Positive views (origin from negative variables).

Definition at line 497 of file bool.hh.

## z

template<class VX, class VY>

VX Gecode::Int::Bool::Clause< VX, VY >::z

protected

Result.

Definition at line 499 of file bool.hh.

## n_zero

template<class VX, class VY>

int Gecode::Int::Bool::Clause< VX, VY >::n_zero

protected

The number of views assigned to zero in x and y.

Definition at line 501 of file bool.hh.

## c

template<class VX, class VY>

Council<Tagged> Gecode::Int::Bool::Clause< VX, VY >::c

protected

The advisor council.

Definition at line 513 of file bool.hh.

The documentation for this class was generated from the following files:

- gecode/int/bool.hh
- gecode/int/bool/clause.hpp